<template>
    <div>
        <form v-on:submit.prevent="handleLogin">

            <div v-if="error" class="alert alert-danger">
                {{ error }}
            </div>
            <div class="form-group">
                <label>Email address</label>
                <input type="email" v-model="email" class="form-control" id="email-login" aria-describedby="emailHelp"
                    placeholder="Enter email">
            </div>
            <div class="form-group">
                <label>Password</label>
                <input type="password" v-model="password" class="form-control" placeholder="Password">
            </div>

            <div class="text-center pt-2">
                <button type="submit" class="btn btn-primary w-75 mt-2" v-bind:class="{ disabled: isLoading }">Sign
                    in</button>
            </div>
        </form>

        <div class="row text-center pt-4">
            <div class="col-12 pt-2 border-bottom mb-2">
                I havent registered yet
            </div>
            <div class="col-12 pt-2">
                <a class="btn btn-primary w-50" href="/vue/registration">Registration</a>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';

export default {
    data() {
        return {
            email: '',
            password: '',
            error: null,
            success: null,
            isLoading: false
        }
    },
    props: ['user'],
    methods: {
        handleLogin() {
            this.isLoading = true;
            this.error = null;

            axios
                .post('/login', {
                    email: this.email,
                    password: this.password
                }, {
                    headers: {
                        'Contact-Type': 'application/x-www-form-urlencoded'
                    }
                })
                .then(response => {

                    if (response.headers.location) {
                        window.location.href = '/vue/profile';
                        return;
                    }

                    this.error = 'Unkown error, please try it later';
                    this.email = '';
                    this.password = '';
                }).catch(error => {
                    this.error = 'Unkown error, please try it later';
                    
                    if (error.response.data && error.response.data.error) {
                        this.error = error.response.data.error;
                    }
                })
        },
    },
}
</script>